require 'socket'
require 'rubygems'
require 'json'

module Evepi
    module Evepi_Init_Mixin
        attr_accessor :json_obj
        
        def initialize(sensor)
            json_path = open( '/etc/%s/fuckpath.md' % sensor ).read()
            json_file = File.read(json_path)
            @json_obj = JSON.parse(json_file)
        end
    end

    class Sensor
        include Evepi_Init_Mixin
        
        def get_raw_res(name='fuckname', cmd='fuck')
            hostname = @json_obj[name][0]
            port = @json_obj[name][1]
            s = TCPSocket.open(hostname, port)
            s.send cmd, 0
            line = s.recv(1024)
            s.close
            return line
        end
        
        def get_res_by_key(key, name=@name, cmd="fuck")
            json_str = get_raw_res(name, cmd)
            json_obj = JSON.parse(json_str)
            return json_obj[key]
        end
        
        alias_method :get_res, :get_raw_res

        def test_get_res_loop(name='fuckname')
            while true
                puts sensor.get_raw_res(name)
                sleep(0.5)
            end
        end
    end

    class LCD_Screen
        include Evepi_Init_Mixin
        
        def _write(input_json, name)
            socket = TCPSocket.open(@hostname, @port)
            socket.send input_json, 0
            line = socket.recv(1024)
            socket.close
        end
        
        def write(type, x, y, content, name=@name)
            input_dict = {
                :cursor_whether => type,
                :cursor_i => x,
                :cursor_j => y,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return _write(input_json, name)
        end

        @@CURSOR_SET = 1
        def set_cursor(x, y, name=@name)
            input_dict = {
                :cursor_whether => @@CURSOR_SET,
                :cursor_i => x,
                :cursor_j => y,
            }
            input_json = JSON.dump(input_dict)
            return _write(input_json, name)
        end
        
        def write_at(x, y, content, name=@name)
            input_dict = {
                :cursor_whether => @@CURSOR_SET,
                :cursor_i => x,
                :cursor_j => y,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return _write(input_json, name)
        end
        
        @@CURSOR_APPEND = 0
        def write_after(content, name=@name)
            input_dict = {
                :cursor_whether => @@CURSOR_APPEND,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return _write(input_json, name)
        end

        @@CURSOR_CLEAR = 2
        def clear(name=@name)
            return write(@@CURSOR_CLEAR, 0, 0, nil, name)
        end
    end

    
end