# test LCD out_01
=begin
out = LCD_Screen.new 'out_01'
out.clear
out.set_cursor 0, 1
out.write_after 'f'
out.set_cursor 1, 2
out.write_after 'u'
out.set_cursor 0, 3
out.write_after 'c'
out.set_cursor 1, 4
out.write_after 'k'
out.write_at 0, 6, 'zyw'

class SensorFactory
    def self.createLCDScreen(sensor_name='out_01')
        return LCD_Screen.new sensor_name
    end
end

=end
require 'evepi'
require 'evepi/module'
require 'json'

module Evepi
	class OUT_01
		@@sensor = Sensor.new 'out_01'
		def self._write(input_json, name='fuckname')
			hostname = @@sensor.json_obj[name][0]
            port = @@sensor.json_obj[name][1]
            socket = TCPSocket.open(hostname, port)
            socket.send input_json, 0
            line = socket.recv(1024)
            socket.close
        end

        def self.write(type, x, y, content, name='fuckname')
            input_dict = {
                :cursor_whether => type,
                :cursor_i => x,
                :cursor_j => y,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return self._write(input_json, name)
        end

        @@CURSOR_SET = 1
        def self.set_cursor(x, y, name='fuckname')
            input_dict = {
                :cursor_whether => @@CURSOR_SET,
                :cursor_i => x,
                :cursor_j => y,
            }
            input_json = JSON.dump(input_dict)
            return self._write(input_json, name)
        end
        
        def self.write_at(x, y, content, name='fuckname')
            input_dict = {
                :cursor_whether => @@CURSOR_SET,
                :cursor_i => x,
                :cursor_j => y,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return self._write(input_json, name)
        end
        
        @@CURSOR_APPEND = 0
        def self.write_after(content, name='fuckname')
            input_dict = {
                :cursor_whether => @@CURSOR_APPEND,
                :input_string => content
            }
            input_json = JSON.dump(input_dict)
            return self._write(input_json, name)
        end

        @@CURSOR_CLEAR = 2
        def self.clear(name='fuckname')
            return self.write(@@CURSOR_CLEAR, 0, 0, nil, name)
        end
	end
end